/*
 boards/MMC1.h

  MacFCEU 0.9d8
*/

/* ---- constants */

#define MMC1SerialReset		0x80

#define MMC1Mirror		3
#define MMC1PRGSwapLow		4
#define MMC1PRGSwap16		8
#define MMC1BankMode		0x10
#define MMC1CtlReset		(MMC1PRGSwapLow|MMC1PRGSwap16|MMC1BankMode)
#define MMC1CtlPower		(MMC1CtlReset|MMC1Mirror)
#define MMC1BankSwap4		0x10

#define MMC1WRAMDisable		0x10

/* ---- externs */

extern uint8 MMC1DReg[4];
#define MMC1Ctl MMC1DReg[0]
#define MMC1Bank MMC1DReg[1]
#define MMC1CHR1 MMC1DReg[2]
#define MMC1PRG0 MMC1DReg[3]

extern void (*MMC1CHRHook4)(uint32 A,
	uint8 V);
extern void (*MMC1PRGHook16)(uint32 A,
	uint8 V);

/* ---- prototypes */

DECLFW(MMC1_write);

void MMC1FixCHR(void);
void MMC1FixPRG(void);
void MMC1FixMir(void);
void MMC1SerialClr(void);

void GenMMC1Close(void);
void MMC1_Restore(int v);
void GenMMC1Reset(void);
void GenMMC1Power(void);

void GenMMC1_Init(CartInfo*,
	int prg,
	int chr,
	int wram,
	int battery);

/* boards */

void SAROM_Init(CartInfo*);
void SBROM_Init(CartInfo*);
void SCROM_Init(CartInfo*);
void SEROM_Init(CartInfo*);
void SFROM_Init(CartInfo*);
void SGROM_Init(CartInfo*);
void SHROM_Init(CartInfo*);
void SJROM_Init(CartInfo*);
void SKROM_Init(CartInfo*);
void SLROM_Init(CartInfo*);
void SL1ROM_Init(CartInfo*);
void SL2ROM_Init(CartInfo*);
void SNROM_Init(CartInfo*);
void SOROM_Init(CartInfo*);
void SUROM_Init(CartInfo*);

void SxROM_Init(CartInfo*); //M1
void MMC1A_Init(CartInfo*); //M155

// Event

void MMC1_Event_Init(CartInfo*); //M105
