/*
 boards/MMC3and6.h

  MacFCEU 0.9a2
*/

/* ---- constants */

#define MMC3WRAM_Enabled	0x80
#define MMC3WRAM_ReadOnly	0x40

/* ---- globals */

extern uint8 MMC3cmd, MMC3resetmode, MMC3A000B, MMC3WRAM_ctl;
extern uint8 MMC3IRQReload, MMC3IRQCount, MMC3IRQLatch, MMC3IRQa, MMC3Rev;
extern uint8 MMC3DReg[16];
#define MMC3EXPREGS (MMC3DReg+8) /* For bootleg games, mostly. */

extern uint8 *MMC3WRAM;

extern void (*MMC3pwrap)(uint32 A,
	uint8 V);
extern void (*MMC3cwrap)(uint32 A,
	uint8 V);
extern void (*MMC3mwrap)(uint8 V);

/* ---- prototypes */

DECLFW(MMC3_8CMDWrite); //8-9
DECLFW(MMC3_AMWSWrite); //A-B
DECLFW(MMC3_CIRQWrite); //C-D
DECLFW(MMC3_EIRQWrite); //E-F

void FixMMC3PRG(int V);
void FixMMC3CHR(int V);
void ClockMMC3Counter(void);

void GenMMC3Close(void);
void GenMMC3Power(void);
void GenMMC3Reset(void);
void GenMMC3Restore(int v);

void GenMMC3_Init(CartInfo*,
	int prg,
	int chr,
	int wram,
	int battery);

/* boards */

void TBROM_Init(CartInfo*);
void TEROM_Init(CartInfo*);
void TFROM_Init(CartInfo*);
void TGROM_Init(CartInfo*);
void TNROM_Init(CartInfo*);
void TKROM_Init(CartInfo*);
void TSROM_Init(CartInfo*);
void TLROM_Init(CartInfo*);
void TLSROM_Init(CartInfo*);
void TKSROM_Init(CartInfo*); //M118
void TQROM_Init(CartInfo*); //M119
void TxROM_Init(CartInfo*); //M4

// MMC6

void HKROM_Init(CartInfo*);

// Nitra

void Nitra_TDA_Init(CartInfo*); //M250

// custom/other

void CustomPAL_ZZ_Init(CartInfo*); //M37
void QJ_Init(CartInfo*); //M47
void RexSoftDBZ5_Init(CartInfo*); //M12
void Kasing_STD_Init(CartInfo*); //M115
void SomeriTeam_SL12_Init(CartInfo*); //M116
void Kay_PandaPrince_Init(CartInfo*); //M121
void G37017_Init(CartInfo*); //M208
