/*
 boards/Subor.c

 * MacFCEU 0.9d8
 *
 * Copyright notice for this file:
 *  subor.c Copyright (C) 2005 CaH4e3
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include "mapinc.h"
#include "latch.h"
#include "Subor.h"

#define regs GameMemBlock
#define typeB GameMemBlock[4]

static void SuborxSync(int lo)
{
	int		hi = (regs[2]^regs[3])&31;

	lo = (regs[0]^regs[1])<<1&0x20;
	if (regs[1]&SuborPRGDouble)
		hi = lo+= 0xFE&hi, lo+= typeB^1, hi+= typeB;
	else if (regs[1]&SuborPRGHi16)
		hi+= lo, lo = 31;
	else
		lo+= hi, hi = typeB ? 7:0x20;
	setchr8(0);
	setprg16(0x8000,lo);
	setprg16(0xC000,hi);
}

static DECLFW(M166Write)
{
	regs[A>>13&3] = V;
	SuborxSync(0);
}

static void M166Power(void)
{
	regs[0] = regs[1] = regs[2] = regs[3] = 0;
	SuborxSync(0);
	SetReadHandler(0x8000,0xFFFF,CartBR);
	SetWriteHandler(0x8000,0xFFFF,M166Write);
}

/* mapper 167 */
void SuborA_Init(CartInfo *info)
{
	info->Power = M166Power;
	GameStateRestore = SuborxSync;
	AddExState(regs,4,0,"DREG");
	typeB = 0;
}

/* mapper 166 */
void SuborB_Init(CartInfo *info)
{
	SuborA_Init(info);
	typeB = 1;
}

static void StudyNGameSync(void)
{
	setchr8(0);
	setprg32(0x8000,latch_byte);
}

/* mapper 39 - simple 32KB bankswitch */
void SuborStudyNGame_Init(CartInfo *info)
{
	Latch_Init(info,StudyNGameSync,0,0,0x8000FFFF,0);
}
