/*
 Cursor.c
  FCE Ultra

  MacFCEU 0.9d7
*/

#include "share.h"
#include "../video.h"

#define K PAL_BLACK^1
#define W PAL_WHITE^1
#define D PAL_BGRAY
#define T 0

static const uint8 GunSight[13*13]={
 T,T,T,T,T,T,W,T,T,T,T,T,T,
 T,T,T,T,T,T,K,T,T,T,T,T,T,
 T,T,T,T,T,T,W,T,T,T,T,T,T,
 T,T,T,T,T,T,K,T,T,T,T,T,T,
 T,T,T,T,T,T,T,T,T,T,T,T,T,
 T,T,T,T,T,T,D,T,T,T,T,T,T,
 W,K,W,K,T,D,T,D,T,K,W,K,W,
 T,T,T,T,T,T,D,T,T,T,T,T,T,
 T,T,T,T,T,T,T,T,T,T,T,T,T,
 T,T,T,T,T,T,K,T,T,T,T,T,T,
 T,T,T,T,T,T,W,T,T,T,T,T,T,
 T,T,T,T,T,T,K,T,T,T,T,T,T,
 T,T,T,T,T,T,W,T,T,T,T,T,T,
};
static const uint8 FCEUcursor[11*19]=
{
 W,T,T,T,T,T,T,T,T,T,T,
 W,W,T,T,T,T,T,T,T,T,T,
 W,K,W,T,T,T,T,T,T,T,T,
 W,K,K,W,T,T,T,T,T,T,T,
 W,K,K,K,W,T,T,T,T,T,T,
 W,K,K,K,K,W,T,T,T,T,T,
 W,K,K,K,K,K,W,T,T,T,T,
 W,K,K,K,K,K,K,W,T,T,T,
 W,K,K,K,K,K,K,K,W,T,T,
 W,K,K,K,K,K,K,K,K,W,T,
 W,K,K,K,K,K,W,W,W,W,W,
 W,K,K,W,K,K,W,T,T,T,T,
 W,K,W,T,W,K,K,W,T,T,T,
 W,W,T,T,W,K,K,W,T,T,T,
 W,T,T,T,T,W,K,K,W,T,T,
 T,T,T,T,T,W,K,K,W,T,T,
 T,T,T,T,T,T,W,K,K,W,T,
 T,T,T,T,T,T,W,K,K,W,T,
 T,T,T,T,T,T,T,W,W,T,T,
};

#undef K
#undef W
#undef D
#undef T

/* macro blitter; 2008.06.29 12:58 GMT; removed indexed mode; 2008.06.30 16:32 GMT */
#define _clippedpixloop(d,z,c,s,w,h,x,y,e)		do{ \
 const uint8 *__s=s; PLB_pel *__d=buf; int __c=(y)+h,__z=(x)+w; \
 if(__z>256) __z=256; if(__c>c) __c=c; /* clip bottom-right */ \
 if((__z-=x)<=0||(__c-=y)<=0||x<=-w||y<=-h) break; /* restore, test */ \
 if((y)<0) __c+=y,__s-=(y)*w; else __d+=(y)*z; /* adjust left */ \
 if((x)<0) __z+=x,__s-=x; else __d+=x; /* adjust top */ \
 do{int __x=__z; PLB_pel *__w=__d; const uint8 *__r=__s; do{uint8 __a; \
  if((__a=*__r++)!=0) {e;}}while(++__w,--__x);} \
while(__s+=w,__d+=z,--__c);}while(0)

void FCEU_DrawGunSight(PLB_pel *buf,
	int xc,
	int yc)
{
	xc-= 6, yc-= 6;
	_clippedpixloop(buf,FCEUSCRN_ROWSIZE,240,GunSight,13,13,xc,yc,
		if(__a==PAL_BGRAY) *__w^=0x7F; else *__w=__a^1);
}

void FCEU_DrawCursor(PLB_pel *buf,
	int xc,
	int yc)
{
	_clippedpixloop(buf,FCEUSCRN_ROWSIZE,240,FCEUcursor,11,19,xc,yc,*__w=__a);
}
