/*
 input/FKB.h
  Family Keyboard and variants

 * MacFCEU 0.9d8
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* I'm assuming 0 is 'null' */
#define FKB_F1		0x01
#define FKB_F2		0x02
#define FKB_F3		0x03
#define FKB_F4		0x04
#define FKB_F5		0x05
#define FKB_F6		0x06
#define FKB_F7		0x07
#define FKB_F8		0x08
#define FKB_1		0x09
#define FKB_2		0x0A
#define FKB_3		0x0B
#define FKB_4		0x0C
#define FKB_5		0x0D
#define FKB_6		0x0E
#define FKB_7		0x0F
#define FKB_8		0x10
#define FKB_9		0x11
#define FKB_0		0x12
#define FKB_MINUS	0x13
#define FKB_CARET	0x14
#define FKB_BACKSLASH	0x15
#define FKB_STOP	0x16
#define FKB_ESCAPE	0x17
#define FKB_Q		0x18
#define FKB_W		0x19
#define FKB_E		0x1A
#define FKB_R		0x1B
#define FKB_T		0x1C
#define FKB_Y		0x1D
#define FKB_U		0x1E
#define FKB_I		0x1F
#define FKB_O		0x20
#define FKB_P		0x21
#define FKB_AT		0x22
#define FKB_LBRACKET	0x23
#define FKB_RETURN	0x24
#define FKB_CONTROL	0x25
#define FKB_A		0x26
#define FKB_S		0x27
#define FKB_D		0x28
#define FKB_F		0x29
#define FKB_G		0x2A
#define FKB_H		0x2B
#define FKB_J		0x2C
#define FKB_K		0x2D
#define FKB_L		0x2E
#define FKB_SEMICOLON	0x2F
#define FKB_COLON	0x30
#define FKB_RBRACKET	0x31
#define FKB_KANA	0x32
#define FKB_LEFTSHIFT	0x33
#define FKB_Z		0x34
#define FKB_X		0x35
#define FKB_C		0x36
#define FKB_V		0x37
#define FKB_B		0x38
#define FKB_N		0x39
#define FKB_M		0x3A
#define FKB_COMMA	0x3B
#define FKB_PERIOD	0x3C
#define FKB_SLASH	0x3D
#define FKB_UNDERSCORE	0x3E
#define FKB_RIGHTSHIFT	0x3F
#define FKB_GRAPH	0x40
#define FKB_SPACE	0x41
#define FKB_CLEAR	0x42
#define FKB_INSERT	0x43
#define FKB_DELETE	0x44
#define FKB_UP		0x45
#define FKB_LEFT	0x46
#define FKB_RIGHT	0x47
#define FKB_DOWN	0x48

#define SKB_ESCAPE	0x01
#define SKB_F1		0x02
#define SKB_F2		0x03
#define SKB_F3		0x04
#define SKB_F4		0x05
#define SKB_F5		0x06
#define SKB_F6		0x07
#define SKB_F7		0x08
#define SKB_F8		0x09
#define SKB_F9		0x0A
#define SKB_F10		0x0B
#define SKB_F11		0x0C
#define SKB_F12		0x0D
#define SKB_PAUSE	0x0E
#define SKB_GRAVE	0x0F
#define SKB_1		0x10
#define SKB_2		0x11
#define SKB_3		0x12
#define SKB_4		0x13
#define SKB_5		0x14
#define SKB_6		0x15
#define SKB_7		0x16
#define SKB_8		0x17
#define SKB_9		0x18
#define SKB_0		0x19
#define SKB_MINUS	0x1A
#define SKB_EQUALS	0x1B
#define SKB_BACK	0x1C
#define SKB_INSERT	0x1D
#define SKB_HOME	0x1E
#define SKB_PRIOR	0x1F
#define SKB_NUMLOCK	0x20
#define SKB_DIVIDE	0x21
#define SKB_MULTIPLY	0x22
#define SKB_SUBTRACT	0x23
#define SKB_TAB		0x24
#define SKB_Q		0x25
#define SKB_W		0x26
#define SKB_E		0x27
#define SKB_R		0x28
#define SKB_T		0x29
#define SKB_Y		0x2A
#define SKB_U		0x2B
#define SKB_I		0x2C
#define SKB_O		0x2D
#define SKB_P		0x2E
#define SKB_LBRACKET	0x2F
#define SKB_RBRACKET	0x30
#define SKB_RETURN	0x31
#define SKB_DELETE	0x32
#define SKB_END		0x33
#define SKB_NEXT	0x34
#define SKB_NUMPAD7	0x35
#define SKB_NUMPAD8	0x36
#define SKB_NUMPAD9	0x37
#define SKB_ADD		0x38
#define SKB_CAPITAL	0x39
#define SKB_A		0x3A
#define SKB_S		0x3B
#define SKB_D		0x3C
#define SKB_F		0x3D
#define SKB_G		0x3E
#define SKB_H		0x3F
#define SKB_J		0x40
#define SKB_K		0x41
#define SKB_L		0x42
#define SKB_SEMICOLON	0x43
#define SKB_APOSTROPHE	0x44
#define SKB_NUMPAD4	0x45
#define SKB_NUMPAD5	0x46
#define SKB_NUMPAD6	0x47
#define SKB_LSHIFT	0x48
#define SKB_Z		0x49
#define SKB_X		0x4A
#define SKB_C		0x4B
#define SKB_V		0x4C
#define SKB_B		0x4D
#define SKB_N		0x4E
#define SKB_M		0x4F
#define SKB_COMMA	0x50
#define SKB_PERIOD	0x51
#define SKB_SLASH	0x52
#define SKB_BACKSLASH	0x53
#define SKB_UP		0x54
#define SKB_NUMPAD1	0x55
#define SKB_NUMPAD2	0x56
#define SKB_NUMPAD3	0x57
#define SKB_LCONTROL	0x58
#define SKB_LMENU	0x59
#define SKB_SPACE	0x5A
#define SKB_LEFT	0x5B
#define SKB_DOWN	0x5C
#define SKB_RIGHT	0x5D
#define SKB_NUMPAD0	0x5E
#define SKB_DECIMAL	0x5F
#define SKB_RSHIFT	0x60
#define SKB_RMENU	0x61
#define SKB_RCONTROL	0x62
#define SKB_BREAK	0x63
#define SKB_RESET	0x64
#define SKB_GRETURN	0x65

/* ---- externs */

extern uint8 bufit[0x66];
extern uint8 ksmode, ksindex;

INPUTCFC *FCEU_InitFKB(void);
INPUTCFC *FCEU_InitSuborKB(void);
