/*
 macos/macinput.h

  Created: 2009.01.20
  Revised: 2015.11.11
*/

#define strlistid_keyscan		160

#if !defined(__MACINPUT_H) && !defined(rez) && !defined(derez)
 #define __MACINPUT_H

 typedef ButtConfig	gpbutttype[10];

 typedef struct input_settings
 {
 	boolean		allowudlr, fscore, mic;
	uint8		obusmask;
	int8		uts[3];
	ButtConfig	ppada[12], ppadb[12];
	ButtConfig	quizking[6];
	ButtConfig	ftrainer[12];
	ButtConfig	hypershot[4];
	ButtConfig	mahjong[21];
	gpbutttype	gamepad1, gamepad2, gamepad3, gamepad4;
	ButtConfig	fkb[0x48], skb[0x65];
 } input_settings;

 extern input_settings	inputset;
 #define allowUDLR			inputset.allowudlr
 #define userinputtype			inputset.uts
 #define powerpadsc			(&inputset.ppada)
 #define QuizKingButtons		inputset.quizking
 #define FTrainerButtons		inputset.ftrainer
 #define HyperShotButtons		inputset.hypershot
 #define MahjongButtons			inputset.mahjong
 #define GamePadConfig			(&inputset.gamepad1)
 #define fkbmap				inputset.fkb
 #define skbmap				inputset.skb

 #ifdef TREC_STRUCTS
  static trec	input_trec[] =
  {
	O_TREC(_bool,input_settings,allowudlr),
	O_TREC(_bool,input_settings,fscore),
	O_TREC(_bool,input_settings,mic),
	O_TREC(_hint8,input_settings,obusmask),
	{_int8,OFFSET(input_settings,uts[0]),"porta"},
	{_int8,OFFSET(input_settings,uts[1]),"portb"},
	{_int8,OFFSET(input_settings,uts[2]),"portfc"},
	{3,OFFSET(input_settings,uts),";uts"}, /* for backward compatibility */
	C_TREC(input_settings,ppada),
	C_TREC(input_settings,ppadb),
	C_TREC(input_settings,quizking),
	C_TREC(input_settings,ftrainer),
	C_TREC(input_settings,hypershot),
	C_TREC(input_settings,gamepad1),
	C_TREC(input_settings,gamepad2),
	C_TREC(input_settings,gamepad3),
	C_TREC(input_settings,gamepad4),
	C_TREC(input_settings,fkb),
	C_TREC(input_settings,skb),
	{0}
  };
 #endif

/* ---- globals */

extern boolean inputCmdDown, cidisabled;
extern int8 inputtype[3], inputtypegi[3];

/* ---- prototypes */

int input_dialog(gpbutttype *gamepad,
	int side); /*0=GamePad 1,2; 1=3,4*/
void initializeinput(void);

#endif
