/*
 macos/macvideo.h

  MacFCEU 0.9a1

  Created: 2010.01.08
*/

#ifndef __MACVIDEO_H
 #include "shell.h"

 #define windowid_screen		80

 #if !defined(rez) && !defined(derez)
  extern uint8		mycolorsinvalidate;

  enum
  { /* overscan margins */
  	_ovs_sln, /* starting/ending line/column, NTSC */
  	_ovs_eln,
  	_ovs_scn,
  	_ovs_ecn,
  	_ovs_slp, /* .. PAL */
  	_ovs_elp,
  	_ovs_scp,
  	_ovs_ecp,
	_countof_ovs
  };

  typedef struct video_settings
  {
	uint8		ovs[_countof_ovs];
	uint32		vblsn, vblsp;
	uint8		bgc, vff, ss, fullscreen, vsync, rdis;
	/* putting an 'f' before all these would make 'art' 'fart'.. */
	int8		shp, res, art, frn, bld;
	uint8		mrg;
  } video_settings;

#ifdef TREC_STRUCTS
  static trec	vid_trec[] =
  {
	{_uint8,OFFSET(video_settings,ovs[_ovs_sln]),"sln"},
	{_uint8,OFFSET(video_settings,ovs[_ovs_eln]),"eln"},
	{_uint8,OFFSET(video_settings,ovs[_ovs_scn]),"scn"},
	{_uint8,OFFSET(video_settings,ovs[_ovs_ecn]),"ecn"},
	{_uint8,OFFSET(video_settings,ovs[_ovs_slp]),"slp"},
	{_uint8,OFFSET(video_settings,ovs[_ovs_elp]),"elp"},
	{_uint8,OFFSET(video_settings,ovs[_ovs_scp]),"scp"},
	{_uint8,OFFSET(video_settings,ovs[_ovs_ecp]),"ecp"},
	O_TREC(_uint32,video_settings,vblsn),
	O_TREC(_uint32,video_settings,vblsp),
	O_TREC(_hint8,video_settings,ss),
	O_TREC(_uint8,video_settings,bgc),
	O_TREC(_bool,video_settings,fullscreen),
	O_TREC(_bool,video_settings,vsync),
	O_TREC(_uint8,video_settings,vff),
	O_TREC(_uint8,video_settings,rdis),

	O_TREC(_int8,video_settings,shp),
	O_TREC(_int8,video_settings,res),
	O_TREC(_int8,video_settings,art),
	O_TREC(_int8,video_settings,frn),
	O_TREC(_int8,video_settings,bld),
	O_TREC(_bool,video_settings,mrg),
	{0}
  };
#endif

  extern video_settings	vidset;
  #define srendlinen			vidset.ovs[_ovs_sln]
  #define erendlinen			vidset.ovs[_ovs_eln]
  #define srendlinep			vidset.ovs[_ovs_slp]
  #define erendlinep			vidset.ovs[_ovs_elp]
  #define vblslinesn			vidset.vblsn
  #define vblslinesp			vidset.vblsp
  #define screenshift			vidset.ss
  #define screenrefreshsync		vidset.vsync

  #ifdef __MACWINDOWS__
   extern WindowRef	gamewindow;
   extern GDHandle	gamegdevice;
   extern Rect		gameinitbounds;
   extern CTabPtr	gameclut;

   #define gdbitdepth()			(**(**gamegdevice).gdPMap).pixelSize

   int VideoRetraceSync(GDHandle gdh); /* always returns paramErr in Carbon */
  #endif

  int initializescreen(boolean fs);

  void FCEUD_BlitScreen(PLB_pel *XBuf);

  void videorefresh(uint8 blit);
  void videocolorsinit(void);

  int overscan_dialog(void);

 #endif /*!defined(rez) && !defined(derez)*/
 #define __MACVIDEO_H
#endif
